﻿////-----------------------------------------------
////jqDesigner 设计器
////Date：2021-03-04
////-----------------------------------------------
(function(window, $) {
    var PLUGIN_NAME = "jqDesigner";
    var uid = 0;
    var items = {}
        //********************************************************
        //私有方法
        //********************************************************
    function _init(target, state, options) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        var selector = state.selector;

        selector.addClass("jquery-designer");
        //设计区域
        state.paintPanel = $(`<div class='paintPanel' style="width:` + state.options.imageInfo.width + `px;height:` + state.options.imageInfo.height + `px">`); //画板区域
        state.config = $("<div class='config'></div>"); // 操作区域 
        state.toolbar = $("<div class='toolbar'></div>"); // 文字编辑区域
        state.dragContainer = $("<div class='dragContainer'></div>"); // 模板内容区域
        selector.append(state.paintPanel);
        state.paintPanel.append($("<img src='" + state.options.imageInfo.url + "'/>")) // 背景图
        selector.append(state.config); //右侧编辑区
        state.config.append(state.toolbar);
        state.config.append(state.dragContainer);
        state.paintPanel.on('mousedown', '.move', function(e) {
            e.stopPropagation();
            fn_move(target, this, e);
        })
        state.paintPanel.on('mousedown', '.zoom', function(e) {
                e.stopPropagation();
                boostMove(target, this, e)
            })
            // 删除
        state.paintPanel.on('click', '.delete', function(e) {
                e.stopPropagation();
                removeItem(target, this, e)
            })
            // 选中编辑
        $(document).on('click', '.move', function(e) {
                chooseItem(target, this, e)
            })
            // 加粗
        $(document).on('click', '.weight', function(e) {
                fontWeight(target, this, e)
            })
            // 斜体
        $(document).on('click', '.italics', function(e) {
                Italics(target, this, e)
            })
            // 下划线
        $(document).on('click', '.underLine', function(e) {
                underLine(target, this, e)
            })
            // 提交
        $(document).on('click', '.btn-jq', function(e) {
            // this.$emit("CloseConfigModel");
            upDataConfig()
        })
        rendToolbar(target);
        rendDragItem(target);
        fn_changeColor(target)
        fn_changeFontSize(target)
        dragItem(target)
        initItem(target)
    }

    function rendToolbar(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.toolbars.length; i++) {
            state.toolbar.append(`
            <div class='toolbar-box'>
                <div class='left'>` + options.toolbars[i].name + `:</div>
                <div class='right'>` + options.toolbars[i].cmd + `</div>
            </div>`)
        }
    }

    function initItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var aItem = state.options.configItem
            // console.log(aItem)
        if (aItem.lenfth == 0) { return }
        for (let i = 0; i < aItem.length; i++) {
            var FontWeight = aItem[i].FontStyle.IsBold ? 'bold' : 'normal'
            var IsItalic = aItem[i].FontStyle.IsItalic ? 'italic' : 'normal'
            var underLine = aItem[i].FontStyle.IsUnderLine ? 'underline' : 'none'
            if (aItem[i].Type == 1) {
                $('.paintPanel').append($(`<div  class='itemBox move' data-Type=` + aItem[i].Type + ` data-Name=` + aItem[i].Name + ` data-DefaultValue=` + aItem[i].DefaultValue + ` data-DataField=` + aItem[i].DataField + ` style="z-index:9999;left:` + aItem[i].X + `px;top:` + aItem[i].Y + `px;font-size:` + aItem[i].FontStyle.FontSize + `px;color:` + aItem[i].FontStyle.FontColor + `;font-weight:` + FontWeight + `;text-decoration:` + underLine + `;font-style:` + IsItalic + `;"><div class='content-jq' style="padding-right:10px;">` + aItem[i].DefaultValue + `<span class='delete'>x</span></div></div>`))
            } else {
                $('.paintPanel').append($(`<div class='itemBox imageBox move' data-Type=` + aItem[i].Type + ` data-Name=` + aItem[i].Name + ` data-DefaultValue=` + aItem[i].DefaultValue + ` data-DataField=` + aItem[i].DataField + ` style="z-index:9999;left:` + aItem[i].X + `px;top:` + aItem[i].Y + `px;background:url('` + aItem[i].DefaultValue + `') no-repeat;background-size:100% 100%;width:` + aItem[i].Width + `px;height:` + aItem[i].Height + `px" ><div class='content-jq'><span class='zoom'></span><span class='delete'>x</span></div></div>`))
            }
        }
    }

    function rendDragItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.dragItems.length; i++) {
            if (options.dragItems[i].Type == 1) {
                state.dragContainer.append(`
                    <div class='DragItem' draggable="true" data-item='` + JSON.stringify(options.dragItems[i]) + `'>
                        <div class='left'>` + options.dragItems[i].Name + `:</div>
                        <div class='right'>` + options.dragItems[i].DefaultValue + `</div>
                    </div>
                `)
            } else {
                state.dragContainer.append(`
                <div class='DragItem-img DragItem' data-item='` + JSON.stringify(options.dragItems[i]) + `'>
                    <img src='` + options.dragItems[i].DefaultValue + `' />
                </div>
            `)
            }
        }
        // state.dragContainer.append(`<button class="btn-jq">提交</button>`)
    }
    // 操作类 切换颜色
    function fn_changeColor(target) {
        var state = $.data(target, PLUGIN_NAME);
        $('#colorInput').change(function() {
            var color = $(this).val();
            $(items).css({
                'color': color
            })
        });
    }
    // 切换字号
    function fn_changeFontSize(target) {
        $('#fontSize').change(function() {
            var value = $(this).val();
            $(items).css({
                'fontSize': value + 'px'
            })
        });
        var state = $.data(target, PLUGIN_NAME);
    }

    function Italics(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        if ($(items).css('fontStyle') == 'italic') {
            $(item).css({
                background: 'none'
            })
            $(items).css({
                'fontStyle': 'normal'
            })
        } else {
            $(item).css({
                background: '#ccc'
            })
            $(items).css({
                'fontStyle': ' italic'
            })
        }
    }

    function fontWeight(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        if ($(items).css('fontWeight') == '700') {
            $(item).css({
                background: 'none'
            })
            $(items).css({
                'fontWeight': 'normal'
            })
        } else {
            $(item).css({
                background: '#ccc'
            })
            $(items).css({
                'fontWeight': 'bold'
            })
        }
    }

    function underLine(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        // console.log($(items).css('textDecoration').indexOf('underline'))
        if ($(items).css('textDecoration').indexOf('underline') != -1) {
            $(item).css({
                background: 'none'
            })
            $(items).css({
                'text-decoration': 'none'
            })
        } else {
            $(item).css({
                background: '#ccc'
            })
            $(items).css({
                'text-decoration': 'underline'
            })
        }
    }

    //  元素拖拽移动
    function fn_move(target, item, e) {
        var state = $.data(target, PLUGIN_NAME);
        // console.log(state)
        let oDiv = $(item)
            // console.log(oDiv)
        let disX = e.clientX - oDiv.offset().left;
        let disY = e.clientY - oDiv.offset().top;
        // console.log(disX + ',' + disY)
        state.options.item = $(item)
        var oBoxDiv = $('.paintPanel')
            // console.log(oBoxDiv.offset().top)
        $(document).mousemove(function(e) {
            let left = e.clientX - disX - oBoxDiv.offset().left;
            let top = e.clientY - disY - oBoxDiv.offset().top;
            let maxY = oBoxDiv[0].clientHeight - oDiv[0].clientHeight
            let maxX = oBoxDiv[0].clientWidth - oDiv[0].clientWidth
                // console.log(e.clientX + ',' + e.clientY)
            if (left <= 0) {
                left = 0
            }
            if (left >= maxX) {
                left = maxX
            }
            if (top <= 0) {
                top = 0
            }
            if (top >= maxY) {
                top = maxY
            }
            // this.X = left
            // this.Y = top
            oDiv.css({
                'left': left + 'px',
                'top': top + 'px'
            });
        });
        $(document).mouseup(function() {
            $(document).off('mousemove');
        });
    }

    function removeItem(target, item, e) {
        var box2 = $(item).parent().parent()
        box2.remove()
    }
    // 改变元素宽高
    function boostMove(target, item, e) {
        e.stopPropagation();
        e.cancelBubble = true;
        var box2 = $(item).parent().parent()
        var state = $.data(target, PLUGIN_NAME);
        var oBoxDiv = state.paintPanel
        var oBoost = $(item)
        var width = box2.width();
        var height = box2.height();
        var nowX = e.clientX;
        var nowY = e.clientY;
        document.onmousemove = function(e) {
            var a = width + e.clientX - nowX;
            var b = height + e.clientY - nowY;
            if (a > oBoxDiv.width()) {
                a = oBoxDiv.width();
            }
            if (b > oBoxDiv.height()) {
                b = oBoxDiv.height();
            }
            box2.css({
                'width': a + "px",
                'height': b + "px"
            })
            box2.data('config', { Width: a, Height: b });
        }
        document.onmouseup = (e) => {
            document.onmousemove = null
            document.onmouseup = null
        }
    }

    // 添加模板信息到画板
    function add(target, item, htmlId, X, Y) {
        // debugger
        var state = $.data(target, PLUGIN_NAME);
        var dragItem = JSON.parse(item)
        item = JSON.parse(item)
        if (dragItem.Type == 2) {
            $(htmlId).append($(`<div onload="alert(8888)" class='itemBox imageBox move' data-DataField=` + item.DataField + ` data-DefaultValue=` + item.DefaultValue + ` data-Type=` + item.Type + ` data-Name=` + item.Name + ` style="z-index:9999;left:` + X + `;top:` + Y + `;background:url('` + dragItem.DefaultValue + `') no-repeat;background-size:100% 100%;" ><div class='content-jq'><span class='zoom'></span><span class='delete'>x</span></div></div>`))
        } else {
            var DefaultValue = JSON.stringify(item.DefaultValue)
            console.log(item.DefaultValue)
            $(htmlId).append($(`<div class='itemBox move' data-DataField=` + item.DataField + ` data-DefaultValue=` + DefaultValue + ` data-Type=` + item.Type + ` data-Name=` + item.Name + ` style="z-index:9999;left:` + X + `;top:` + Y + `"><div class='content-jq' style="padding-right:10px">` + item.DefaultValue + `<span class='delete'>x</span></div></div>`))
        }
        // htmlId.html(`<span class='itemBox' style="z-index:9999">` + dragItem.DefaultValue + `</span>`)
    }

    function dragItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var coloList = []
        $(document).on('dragstart', '.DragItem', function(e) { // 拖拽事件绑定到元素上
            var DragItem = $(this).attr("data-item") // 获取到元素绑定的属性值
            $(document).on('dragenter', '.paintPanel', function() {})
            $(document).on('dragover', '.paintPanel', function(event) { // 这行代码一定要有，阻止事件的默认行为，才能触发鼠标放下的事件
                event.preventDefault()
            })
            state.paintPanel.on('drop', function(e) { // // 鼠标放下事件被触发把元素添加到bbox中
                // console.log(document.documentElement.scrollTop)
                var X = (e.originalEvent.clientX - state.paintPanel.offset().left) + 'px';
                var Y = (e.originalEvent.clientY - state.paintPanel.offset().top + document.documentElement.scrollTop) + 'px';
                debugger
                add(target, DragItem, state.paintPanel, X, Y)
            })
            $(document).on('drop', '.paintPanel', function(e) { // 定时器解绑事件，不然会一直绑定事件，重复添加数据
                var timer = setInterval(function() {
                    state.paintPanel.off('dragover')
                    state.paintPanel.off('dragenter')
                    state.paintPanel.off('drop')
                    clearInterval(timer);
                }, 30)
            })
        })
    }

    function chooseItem(target, item, e) {
        var state = $.data(target, PLUGIN_NAME);
        items = $(item)
        $('.move').css({
            backgroundColor: ''
        })
        $(item).css({
                backgroundColor: 'rgba(255, 0, 0, .1)'
            })
            // 颜色一致
        var color = $(items).css('color')
        $('#colorInput').val(rgb(color))
            // 字体大小一致
        var FontSize = $(items).css('fontSize').substring(0, 2)
        $(`#fontSize option[value=` + FontSize + `]`).attr("selected", true)
            // 下划线
        var underLine = $(items).css('text-decoration').indexOf('underline')
        if (underLine != -1) {
            $('.underLine').css({
                backgroundColor: '#ccc'
            })
        }
        // 加粗
        var FontWeight = $(items).css('fontWeight')
        if (FontWeight == 700) {
            $('.weight').css({
                backgroundColor: '#ccc'
            })
        }
        // 斜体
        var italics = $(items).css('fontStyle')
        if (italics == 'italic') {
            $('.italics').css({
                backgroundColor: '#ccc'
            })
        }
    }

    function rgb(rgb) {
        if (rgb.charAt(0) == '#')
            return rgb;
        var ds = rgb.split(/\D+/);
        var decimal = Number(ds[1]) * 65536 + Number(ds[2]) * 256 + Number(ds[3]);
        return "#" + zero_fill_hex(decimal, 6);
    }

    function zero_fill_hex(num, digits) {
        var s = num.toString(16);
        while (s.length < digits)
            s = "0" + s;
        return s;
    }

    function upDataConfig(target) {
        var aData = $('.move')
        var config = []
        for (let i = 0; i < aData.length; i++) {
            config.push({
                DataField: $(aData[i]).data('datafield'),
                DefaultValue: $(aData[i]).data('defaultvalue'),
                Name: $(aData[i]).data('name'),
                Type: $(aData[i]).data('type'),
                Width: Math.ceil(Number(($(aData[i]).css('width')).replace("px", ""))),
                Height: Math.ceil(Number(($(aData[i]).css('height')).replace("px", ""))),
                X: Math.ceil(Number(($(aData[i]).css('left')).replace("px", ""))),
                Y: Math.ceil(Number(($(aData[i]).css('top')).replace("px", ""))),
                FontStyle: {
                    FontSize: Number(($(aData[i]).css('fontSize')).replace("px", "")),
                    FontColor: '#333',
                    IsBold: $(aData[i]).css('fontWeight') == 700 ? true : false,
                    IsItalic: $(aData[i]).css('fontStyle') == 'italic' ? true : false,
                    IsUnderLine: $(aData[i]).css('textDecoration').indexOf('underline') != -1 ? true : false,
                    FontName: '微软雅黑'
                }
            })
        }
        // console.log(config)
        return config
    }

    function _destroy(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        state.selector.remove();
        $(document).off('.btn-jq');
        //state.selecter.show();
        console.log(state.selector)
        $.data(target, PLUGIN_NAME, null);
    }

    function _getConfig(target) {
        var state = $.data(target, PLUGIN_NAME);
    }
    $.fn[PLUGIN_NAME] = function(options) {
        if (typeof options === 'string' && $.fn[PLUGIN_NAME].methods[options]) {
            return $.fn[PLUGIN_NAME].methods[options].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof options === 'object' || !options) {
            return $.fn[PLUGIN_NAME].methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + options + ' does not exist on jQuery' + PLUGIN_NAME);
        }
    };
    $.fn[PLUGIN_NAME].version = "1.0";
    $.fn[PLUGIN_NAME].defaults = {
        toolbars: [],
        dragItems: [],
        configItem: [],
        imageInfo: {}
    };
    $.fn[PLUGIN_NAME].methods = {
        init: function(options) {
            return this.each(function() {
                var $this = $(this);
                var state = $.data(this, PLUGIN_NAME);
                if (state) {
                    $.extend(state.options, options);
                } else {
                    var settings = $.extend({}, $.fn[PLUGIN_NAME].defaults, options);
                    state = $.data(this, PLUGIN_NAME, {
                        target: this,
                        selector: $this,
                        options: settings,
                        vars: {},
                    });
                    _init(this, state, options);
                }
            });
        },
        destroy: function() {
            return this.each(function() {
                _destroy(this);
            });
        },
        getConfig: function() {
            return upDataConfig(this[0])
                // return _getSelections(this[0]);
        },
    };
})(window, jQuery);